comonad-4.2.7.2: Comonads

Copyright | (C) 2008-2014 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable (fundeps, MPTCs)
Safe Haskell | Safe
Language | Haskell2010

Control.Comonad.Store

Contents

- ComonadStore class
- The Store comonad
- The StoreT comonad transformer
- Re-exported modules

Description

Synopsis

- class Comonad w => ComonadStore s w | w -> s where
  - pos :: w a -> s
  - peek :: s -> w a -> a
  - peeks :: (s -> s) -> w a -> a
  - seek :: s -> w a -> w a
  - seeks :: (s -> s) -> w a -> w a
  - experiment :: Functor f => (s -> f s) -> w a -> f a
- type Store s = StoreT s Identity
- store :: (s -> a) -> s -> Store s a
- runStore :: Store s a -> (s -> a, s)
- data StoreT s w a = StoreT (w (s -> a)) s
- runStoreT :: StoreT s w a -> (w (s -> a), s)
- module Control.Comonad
- module Control.Comonad.Trans.Class

# ComonadStore class

class Comonad w => ComonadStore s w | w -> s where Source

Minimal complete definition

pos, peek

Methods

pos :: w a -> s Source

peek :: s -> w a -> a Source

peeks :: (s -> s) -> w a -> a Source

seek :: s -> w a -> w a Source

seeks :: (s -> s) -> w a -> w a Source

experiment :: Functor f => (s -> f s) -> w a -> f a Source

Instances

ComonadStore s w => ComonadStore s (IdentityT w) Source |
(ComonadStore s w, Monoid m) => ComonadStore s (TracedT m w) Source |
ComonadStore s w => ComonadStore s (EnvT e w) Source |
Comonad w => ComonadStore s (StoreT s w) Source |

# The Store comonad

type Store s = StoreT s Identity Source

store :: (s -> a) -> s -> Store s a Source

Create a Store using an accessor function and a stored value

runStore :: Store s a -> (s -> a, s) Source

# The StoreT comonad transformer

data StoreT s w a Source

Constructors

StoreT (w (s -> a)) s |

Instances

ComonadEnv e w => ComonadEnv e (StoreT t w) Source |
Comonad w => ComonadStore s (StoreT s w) Source |
ComonadTraced m w => ComonadTraced m (StoreT s w) Source |
ComonadTrans (StoreT s) Source |
ComonadHoist (StoreT s) Source |
Functor w => Functor (StoreT s w) Source |
(Applicative w, Monoid s) => Applicative (StoreT s w) Source |
(ComonadApply w, Semigroup s) => ComonadApply (StoreT s w) Source |
Comonad w => Comonad (StoreT s w) Source |

runStoreT :: StoreT s w a -> (w (s -> a), s) Source

# Re-exported modules

module Control.Comonad

module Control.Comonad.Trans.Class